package plugin;

import java.util.HashSet;
import java.util.Set;

public abstract class AbstractPlugin {

	public PluginClassLoader loader;
	
	private String id;
	public String getPluginId(){
		return id;
	}
		
	private Set requiredPlugins=new HashSet();

	protected AbstractPlugin(String id){
		this.id = id;
	}

	public void addRequiredPlugin(AbstractPlugin required){
		requiredPlugins.add(required);
	}
	
	public Set requiredPlugins(){
		return new HashSet(requiredPlugins);
	}
	
	private Set extensionPoints = new HashSet();
	public Set getExtensionPoints(){
		return new HashSet(extensionPoints);
	}
	public void addExtensionPoint(ExtensionPoint ep){
		extensionPoints.add(ep);
	}
	
	public void run(String[] args){
		
	}
	
	public final boolean equals(Object o){
		return (o instanceof AbstractPlugin) && ((AbstractPlugin)o).id.equals(id);
	}

	public final int hashCode(){
		return id.hashCode();
	}
}
